commit c5a26fc24b0af61498fae65ccad69d51d63d2a8b
Author: Uros Bizjak <ubizjak@gmail.com>
Date:   Wed Jul 17 18:11:26 2024 +0200

    alpha: Fix duplicate !tlsgd!62 assemble error [PR115526]
    
    Add missing "cannot_copy" attribute to instructions that have to
    stay in 1-1 correspondence with another insn.
    
            PR target/115526
    
    gcc/ChangeLog:
    
            * config/alpha/alpha.md (movdi_er_high_g): Add cannot_copy attribute.
            (movdi_er_tlsgd): Ditto.
            (movdi_er_tlsldm): Ditto.
            (call_value_osf_<tls>): Ditto.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/alpha/pr115526.c: New test.
    
    (cherry picked from commit 0841fd4c42ab053be951b7418233f0478282d020)

diff --git a/gcc/testsuite/gcc.target/alpha/pr115526.c b/gcc/testsuite/gcc.target/alpha/pr115526.c
new file mode 100644
index 00000000000..2f57903fec3
--- /dev/null
+++ b/gcc/testsuite/gcc.target/alpha/pr115526.c
@@ -0,0 +1,46 @@
+/* PR target/115526 */
+/* { dg-do assemble } */
+/* { dg-options "-O2 -Wno-attributes -fvisibility=hidden -fPIC -mcpu=ev4" } */
+
+struct _ts {
+  struct _dtoa_state *interp;
+};
+struct Bigint {
+  int k;
+} *_Py_dg_strtod_bs;
+struct _dtoa_state {
+  struct Bigint p5s;
+  struct Bigint *freelist[];
+};
+extern _Thread_local struct _ts _Py_tss_tstate;
+typedef struct Bigint Bigint;
+int pow5mult_k;
+long _Py_dg_strtod_ndigits;
+void PyMem_Free();
+void Bfree(Bigint *v) {
+  if (v)
+    {
+      if (v->k)
+	PyMem_Free();
+      else {
+	struct _dtoa_state *interp = _Py_tss_tstate.interp;
+	interp->freelist[v->k] = v;
+      }
+    }
+}
+static Bigint *pow5mult(Bigint *b) {
+  for (;;) {
+    if (pow5mult_k & 1) {
+      Bfree(b);
+      if (b == 0)
+        return 0;
+    }
+    if (!(pow5mult_k >>= 1))
+      break;
+  }
+  return 0;
+}
+void _Py_dg_strtod() {
+  if (_Py_dg_strtod_ndigits)
+    pow5mult(_Py_dg_strtod_bs);
+}

